import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _class_call_check } from "@swc/helpers/_/_class_call_check";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { FS_RESOURCE } from "@modern-js/codesmith";
import { renderString } from "./utils";
var EjsAPI = /* @__PURE__ */ function() {
  "use strict";
  function EjsAPI2(generatorCore) {
    _class_call_check(this, EjsAPI2);
    this.generatorCore = generatorCore;
  }
  var _proto = EjsAPI2.prototype;
  _proto.renderTemplate = function renderTemplate(templateResource, target) {
    var parameters = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    var _this = this;
    return _async_to_generator(function() {
      var resourceValue;
      return _ts_generator(this, function(_state) {
        switch (_state.label) {
          case 0:
            if (templateResource._type !== FS_RESOURCE) {
              throw new Error("resource not match");
            }
            return [
              4,
              templateResource.value()
            ];
          case 1:
            resourceValue = _state.sent();
            if (typeof resourceValue.content !== "string") {
              throw new Error("resource.value is not string, resourceValue=".concat(resourceValue));
            }
            return [
              4,
              _this.generatorCore.output.fs(target, renderString(resourceValue.content, parameters), {
                encoding: "utf-8"
              })
            ];
          case 2:
            _state.sent();
            return [
              2
            ];
        }
      });
    })();
  };
  _proto.renderTemplateDir = function renderTemplateDir(material, findGlob, target, options) {
    var _this = this;
    return _async_to_generator(function() {
      var resourceMap;
      return _ts_generator(this, function(_state) {
        switch (_state.label) {
          case 0:
            return [
              4,
              material.find(findGlob, _object_spread({
                nodir: true
              }, options))
            ];
          case 1:
            resourceMap = _state.sent();
            return [
              4,
              Promise.all(
                // resourceKey is relate path. example: in `garr-master/package.json`, package.json is resourceKey
                Object.keys(resourceMap).map(function() {
                  var _ref = _async_to_generator(function(resourceKey) {
                    return _ts_generator(this, function(_state2) {
                      switch (_state2.label) {
                        case 0:
                          _this.generatorCore.logger.debug("💡 [EJS Render Template Dir]: resourceKey=".concat(resourceKey));
                          return [
                            4,
                            _this.renderTemplate(material.get(resourceKey), target(resourceKey), options === null || options === void 0 ? void 0 : options.parameters)
                          ];
                        case 1:
                          _state2.sent();
                          return [
                            2
                          ];
                      }
                    });
                  });
                  return function(resourceKey) {
                    return _ref.apply(this, arguments);
                  };
                }())
              )
            ];
          case 2:
            _state.sent();
            return [
              2
            ];
        }
      });
    })();
  };
  return EjsAPI2;
}();
export {
  EjsAPI,
  renderString
};
